"use strict";
function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}
Object.defineProperty(exports, "__esModule", { value: !0 });
var sheet = require("@emotion/sheet"),
  utils = require("@emotion/utils"),
  Stylis = _interopDefault(require("@emotion/stylis")),
  delimiter = "/*|*/",
  needle = delimiter + "}";
function toSheet(block) {
  block && current.push(block + "}");
}
var current,
  ruleSheet = function(
    context,
    content,
    selectors,
    parents,
    line,
    column,
    length,
    ns,
    depth,
    at
  ) {
    switch (context) {
      case -1:
        current = [];
        break;
      case 1:
        switch (content.charCodeAt(0)) {
          case 64:
            if (0 === depth) return current.push(content + ";"), "";
            break;
          case 108:
            if (98 === content.charCodeAt(2)) return "";
        }
        break;
      case 2:
        if (0 === ns) return content + delimiter;
        break;
      case 3:
        switch (ns) {
          case 102:
          case 112:
            return current.push(selectors[0] + content), "";
          default:
            return content + (0 === at ? delimiter : "");
        }
      case -2:
        return content.split(needle).forEach(toSheet), current;
    }
  },
  createCache = function(options) {
    void 0 === options && (options = {});
    var stylisOptions,
      key = options.key || "css";
    void 0 !== options.prefix && (stylisOptions = { prefix: options.prefix });
    var stylis = new Stylis(stylisOptions);
    stylis.use(options.stylisPlugins)(ruleSheet);
    var container,
      inserted = {};
    if (utils.isBrowser) {
      container = options.container || document.head;
      var nodes = document.querySelectorAll("style[data-emotion-" + key + "]");
      Array.prototype.forEach.call(nodes, function(node) {
        node
          .getAttribute("data-emotion-" + key)
          .split(" ")
          .forEach(function(id) {
            inserted[id] = !0;
          }),
          node.parentNode !== container && container.appendChild(node);
      });
    }
    return {
      stylis: stylis,
      key: key,
      sheet: new sheet.StyleSheet({
        key: key,
        container: container,
        nonce: options.nonce,
        speedy: options.speedy
      }),
      nonce: options.nonce,
      inserted: inserted,
      registered: {}
    };
  };
exports.default = createCache;
